type PlayerOne = {
    kind: "playerOne";
    name: string;
};
type PlayerTwo = {
    kind: "playerTwo";
    name: string;
};
type Player = PlayerOne | PlayerTwo;
type Point = "love" | "15" | "30";
type Deuce = {
    kind: "deuce";
};
type PointsData = {
    kind: "points";
    playerOnePoint: Point;
    playerTwoPoint: Point;
};
type FortyData = {
    kind: "forty";
    player: Player;
    otherPlayerPoint: Point;
};
type Advantage = {
    kind: "advantage",
    player: Player
};
type Game = {
    kind: "game",
    player: Player
    // otherPlayerPoint: ? Not representable here.
};
type Score = Deuce | PointsData | FortyData | Advantage | Game;

const s1: Score = {
    kind: "points",
    playerOnePoint: "30",
    playerTwoPoint: "love",
};

const s2: Score = {
    kind: "deuce",
};

const s3: Score = {
    kind: "forty",
    player: { kind: "playerOne", name: "Serena" },
    otherPlayerPoint: "love",
};

const s4: Score = {
    kind: "advantage",
    player: { kind: "playerTwo", name: "Venus" },
};

const s5: Score = {
    kind: "game",
    player: { kind: "playerOne", name: "Martina" },
};
